﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace howto_paste_png
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Paste image data from the clipboard.
        private void picOriginal_MouseClick(object sender, MouseEventArgs e)
        {
            // Try to get an image.
            Image clipboard_image = GetClipboardImage();

            // If we failed. Beep to tell the user that
            // we cannot paste the available formats.
            if (clipboard_image == null)
            {
                System.Media.SystemSounds.Beep.Play();
                return;
            }

            // Draw on the image.
            using (Graphics gr = Graphics.FromImage(picOriginal.Image))
            {
                Rectangle source_rect = new Rectangle(0, 0,
                    clipboard_image.Width, clipboard_image.Height);
                int x = e.X - clipboard_image.Width / 2;
                int y = e.Y - clipboard_image.Height / 2;
                Rectangle dest_rect = new Rectangle(x, y,
                    clipboard_image.Width, clipboard_image.Height);
                gr.DrawImage(clipboard_image,
                    dest_rect, source_rect, GraphicsUnit.Pixel);
            }
            picOriginal.Refresh();
        }

        // Get a PNG from the clipboard if possible.
        // Otherwise try to get a bitmap.
        private Image GetClipboardImage()
        {
            // Try to paste PNG data.
            if (Clipboard.ContainsData("PNG"))
            {
                Object png_object = Clipboard.GetData("PNG");
                if (png_object is MemoryStream)
                {
                    MemoryStream png_stream = png_object as MemoryStream;
                    return Image.FromStream(png_stream);
                }
            }

            // Try to paste bitmap data.
            if (Clipboard.ContainsImage())
            {
                return Clipboard.GetImage();
            }

            // We couldn't find anything useful. Return null.
            return null;
        }
    }
}
